"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadBackgroundImage = exports.initImageClasses = exports.initImageBackgroundClasses = void 0;

var _ci = require("../common/ci.utils");

var loadBackgroundImage = function loadBackgroundImage(event) {
  var bgContainer = event.target;
  var bg = bgContainer.getAttribute('data-bg');

  if (bg) {
    var optimizedImage = new Image();

    optimizedImage.onload = function () {
      (0, _ci.addClass)(bgContainer, 'ci-image-loaded');
      bgContainer.removeAttribute('data-bg');
      bgContainer.removeAttribute('ci-preview');
    };

    optimizedImage.src = bg;
    bgContainer.style.backgroundImage = 'url(' + bg + ')';
  }
};

exports.loadBackgroundImage = loadBackgroundImage;

var initImageClasses = function initImageClasses(_ref) {
  var imgNode = _ref.imgNode,
      lazy = _ref.lazy;
  (0, _ci.addClass)(imgNode, 'ci-image');

  if (lazy) {
    (0, _ci.addClass)(imgNode, 'lazyload');
  }
};

exports.initImageClasses = initImageClasses;

var initImageBackgroundClasses = function initImageBackgroundClasses(_ref2) {
  var imgNode = _ref2.imgNode,
      lazy = _ref2.lazy;
  (0, _ci.addClass)(imgNode, 'ci-bg');

  if (lazy) {
    (0, _ci.addClass)(imgNode, 'lazyload');
  }
};

exports.initImageBackgroundClasses = initImageBackgroundClasses;